// src/identity/crypto.ts
import { getPublicKeyAsync, utils } from "@noble/ed25519";
function convertKeypairToHex({
  privateKeyBytes,
  publicKeyBytes
}) {
  return {
    publicKey: `0x${Buffer.from(publicKeyBytes).toString("hex")}`,
    privateKey: `0x${Buffer.from(privateKeyBytes).toString("hex")}`
  };
}
async function createKeypairEDDSA() {
  const privateKeyBytes = utils.randomPrivateKey();
  const publicKeyBytes = await getPublicKeyAsync(privateKeyBytes);
  return {
    privateKeyBytes,
    publicKeyBytes
  };
}

export {
  convertKeypairToHex,
  createKeypairEDDSA
};
