import { FrameContextManager, Storage } from './types.js';
import '../hooks/use-visibility-detection.js';

type UseFrameContextOptions<TFrameContext extends Record<string, unknown>> = {
    fallbackContext: TFrameContext;
    /**
     * @defaultValue WebStorage
     */
    storage?: Storage;
    storageKey?: string;
};
type CreateFrameContextHookOptions = {
    storageKey: string;
};
declare function createFrameContextHook<TFrameContext extends Record<string, unknown>>(options: CreateFrameContextHookOptions): ({ fallbackContext, storage, storageKey, }: UseFrameContextOptions<TFrameContext>) => FrameContextManager<TFrameContext>;

export { createFrameContextHook };
