import { N as FramesStackItem, M as FrameStackMessage, L as FrameStackRequestError, J as FrameStackDone, I as GetFrameResult } from '../types-0pyvZInF.js';
import { PartialFrame } from './types.js';
import 'frames.js';
import 'react';
import 'frames.js/frame-parsers';
import 'frames.js/types';
import '@farcaster/core';

type FrameResultFailure = Exclude<GetFrameResult, {
    status: "success";
}>;
type FrameStackItemWithPartialFrame = Omit<FrameStackDone, "frameResult"> & {
    frameResult: Omit<FrameResultFailure, "frame"> & {
        frame: PartialFrame;
    };
};
declare function isPartialFrameStackItem(stackItem: FramesStackItem): stackItem is FrameStackItemWithPartialFrame;
declare function getErrorMessageFromFramesStackItem(item: FrameStackMessage | FrameStackRequestError): string;

export { getErrorMessageFromFramesStackItem, isPartialFrameStackItem };
